Imports System.IO
Imports System.Linq
Imports Windows.Foundation
Imports Windows.Foundation.Collections
Imports Windows.UI.Xaml
Imports Windows.UI.Xaml.Controls
Imports Windows.UI.Xaml.Controls.Primitives
Imports Windows.UI.Xaml.Data
Imports Windows.UI.Xaml.Input
Imports Windows.UI.Xaml.Media
Imports Windows.UI.Xaml.Navigation
Imports System.Net.Http
Imports Windows.Data.Json
Imports Windows.UI.Xaml.Shapes
Imports Windows.UI
Imports System
' The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

''' <summary>
''' An empty page that can be used on its own or navigated to within a Frame.
''' </summary>
Partial Public NotInheritable Class MainPage
    Inherits Page

    Public Sub New()
        Me.InitializeComponent()
    End Sub

    ''' <summary>
    ''' Invoked when this page is about to be displayed in a Frame.
    ''' </summary>
    ''' <param name="e">Event data that describes how this page was reached.  The Parameter
    ''' property is typically used to configure the page.</param>
    Protected Overrides Sub OnNavigatedTo(ByVal e As NavigationEventArgs)
    End Sub

    Private Sub AddCircle(ByVal color As Color, ByVal diameter As Integer, ByVal t As Integer, ByVal l As Integer)
        '
        ' Build a circle using the attributes provided as parameters.
        ' 
        Dim newColoredCircle As New Ellipse
        newColoredCircle.Fill = New SolidColorBrush(color)
        newColoredCircle.StrokeThickness = 1
        newColoredCircle.Stroke = New SolidColorBrush(color)
        newColoredCircle.Width = diameter
        newColoredCircle.Height = diameter
        '
        ' Add the circle to the Canvas control.
        ' 
        myCanvas.Children.Add(newColoredCircle)
        Canvas.SetTop(newColoredCircle, t)
        Canvas.SetLeft(newColoredCircle, l)
    End Sub

    Private Function CircleColorFromString(ByVal rgb As String) As Color
        '
        ' Convert the string-based hex values 
        ' into a Color object and return to caller.
        ' 
        Dim ringColor As New Color
        Dim a As Byte = 255
        Dim r As Byte = CByte(Convert.ToUInt32(rgb.Substring(1, 2), 16))
        Dim g As Byte = CByte(Convert.ToUInt32(rgb.Substring(3, 2), 16))
        Dim b As Byte = CByte(Convert.ToUInt32(rgb.Substring(5, 2), 16))
        ringColor = Color.FromArgb(a, r, g, b)
        Return ringColor
    End Function

    Private Async Sub GridLoadedEvent(ByVal sender As Object, ByVal e As RoutedEventArgs)
        '
        ' Retrieve colors from web service
        '
        Dim client As HttpClient = New HttpClient
        client.MaxResponseContentBufferSize = 1024 * 1024

        '
        ' Asynchronously call into the web service
        ' 
        Dim response As HttpResponseMessage = Await client.GetAsync(New Uri("http://localhost:1165/api/values"))

        Dim result As String = Await response.Content.ReadAsStringAsync

        '
        ' Parse the JSON data
        '
        Dim parsedResults As JsonArray = JsonArray.Parse(result)

        '
        ' Build concentric circles, repeating colors as needed
        '

        Const startingPercentage As Double = 1.0
        Const desiredCircleCount As Double = 50.0
        Dim i As Integer
        For i = 0 To CInt(desiredCircleCount) - 1
            Dim circleColor As Color = CircleColorFromString(parsedResults(i Mod parsedResults.Count).GetString)
            Dim circleDiameter As Integer = Convert.ToInt32((startingPercentage - (i / desiredCircleCount)) * Me.RenderSize.Width / 2.0)
            Dim top As Integer = Convert.ToInt32((Me.RenderSize.Height - circleDiameter) / 2.0)
            Dim left As Integer = Convert.ToInt32((Me.RenderSize.Width - circleDiameter) / 2.0)
            AddCircle(circleColor, circleDiameter, top, left)
        Next i
    End Sub
End Class
